#!/project/tcl/src/brent/wish
#
# This code creates a cascade menu that doesn't work

# Set up the main display
frame .buttons
pack .buttons -fill x
button .buttons.quit -text Quit -command exit
pack .buttons.quit -side right

# Create the menu of different examples.
# Look through the .tcl files for the keywords
# that group the examples.

set browse(dir) $tk_library

foreach f [glob $browse(dir)/*.tcl] {
    if [catch {open $f} in] {
	puts stderr "Cannot open $f: $in"
	continue
    }
    while {[gets $in line] >= 0} {
	if [regexp -nocase {^proc ([^ ]+) } $line x proc] {
	    lappend examples([file tail $f]) $proc
	    close $in
	    break
	}
    }
}
menubutton .buttons.ex -text Examples -menu .buttons.ex.m
pack .buttons.ex -side left
set m [menu .buttons.ex.m]
set i 0
foreach key [lsort [array names examples]] {
    $m add cascade -label $key -menu $m.sub$i
    set sub [menu $m.sub$i -tearoff 0]
    puts stderr "$sub [winfo id $sub]"
    incr i
    foreach item [lsort $examples($key)] {
	$sub add command -label [file tail $item] -command [list Browse $item]
    }
}

frame .body
text .body.t -setgrid true -width 80 -height 25 \
	-yscrollcommand {.body.s set}
scrollbar .body.s -command {.body.t yview} -orient vertical
pack .body.s -side left -fill y
pack .body.t -side right -fill both -expand true
pack .body -side top -fill both -expand true

puts stderr ".body.t [winfo id .body.t]"

wm minsize . 30 5
wm title . "Tcl Example Browser"

# tkMenuLeave --
# This procedure is invoked to handle Leave events for a menu.  It
# deactivates everything unless the active element is a cascade element
# and the mouse is now over the submenu.
#
# Arguments:
# menu -		The menu window.
# rootx, rooty -	Root coordinates of mouse.
# state -		Modifier state.

source $tk_library/menu.tcl

proc tkMenuLeave {menu rootx rooty state} {
    global tkPriv
    set tkPriv(window) {}
    puts "tkMenuLeave $menu ix=[$menu index active] type=[$menu type active] x=$rootx y=$rooty contain=[winfo containing $rootx $rooty]"
    if {[$menu index active] == "none"} {
	return
    }
    if {([$menu type active] == "cascade")
	    && ([winfo containing $rootx $rooty]
	    == [$menu entrycget active -menu])} {
	return
    }
    $menu activate none
}

